• HDU 3342 Legal or Not(有向图判环 拓扑排序)


    Legal or Not

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 11382    Accepted Submission(s): 5346


    Problem Description
    ACM-DIY is a large QQ group where many excellent acmers get together. It is so harmonious that just like a big family. Every day,many "holy cows" like HH, hh, AC, ZT, lcc, BF, Qinz and so on chat on-line to exchange their ideas. When someone has questions, many warm-hearted cows like Lost will come to help. Then the one being helped will call Lost "master", and Lost will have a nice "prentice". By and by, there are many pairs of "master and prentice". But then problem occurs: there are too many masters and too many prentices, how can we know whether it is legal or not?

    We all know a master can have many prentices and a prentice may have a lot of masters too, it's legal. Nevertheless,some cows are not so honest, they hold illegal relationship. Take HH and 3xian for instant, HH is 3xian's master and, at the same time, 3xian is HH's master,which is quite illegal! To avoid this,please help us to judge whether their relationship is legal or not.

    Please note that the "master and prentice" relation is transitive. It means that if A is B's master ans B is C's master, then A is C's master.
     
    Input
    The input consists of several test cases. For each case, the first line contains two integers, N (members to be tested) and M (relationships to be tested)(2 <= N, M <= 100). Then M lines follow, each contains a pair of (x, y) which means x is y's master and y is x's prentice. The input is terminated by N = 0.
    TO MAKE IT SIMPLE, we give every one a number (0, 1, 2,..., N-1). We use their numbers instead of their names.
     
    Output
    For each test case, print in one line the judgement of the messy relationship.
    If it is legal, output "YES", otherwise "NO".
     
    Sample Input
    3 2 0 1 1 2 2 2 0 1 1 0 0 0
     
    Sample Output
    YES NO
     
    Author
    QiuQiu@NJFU
     
    Source
     
    Recommend
    lcy   |   We have carefully selected several similar problems for you:  3333 3341 3336 1811 3335 
     
    判环,自身环不算,自己指向自己
    code:
    #include<stdio.h>
    #include<iostream>
    #include<math.h>
    #include<string.h>
    #include<set>
    #include<map>
    #include<list>
    #include<queue>
    #include<algorithm>
    using namespace std;
    typedef long long LL;
    int mon1[13]= {0,31,28,31,30,31,30,31,31,30,31,30,31};
    int mon2[13]= {0,31,29,31,30,31,30,31,31,30,31,30,31};
    int dir[4][2]= {{0,1},{0,-1},{1,0},{-1,0}};
    
    int getval()
    {
        int ret(0);
        char c;
        while((c=getchar())==' '||c=='
    '||c=='
    ');
        ret=c-'0';
        while((c=getchar())!=' '&&c!='
    '&&c!='
    ')
            ret=ret*10+c-'0';
        return ret;
    }
    
    #define max_v 105
    int indgree[max_v];
    vector<int> vv[max_v];
    int n,m;
    queue<int> q;
    int tpsort()
    {
        while(!q.empty())
            q.pop();
        for(int i=1;i<=n;i++)
            if(indgree[i]==0)
                 q.push(i);
        int c=0;
        int temp;
        while(!q.empty())
        {
            temp=q.front();
            q.pop();
            c++;
            for(int i=0;i<vv[temp].size();i++)
            {
                indgree[vv[temp][i]]--;
                if(indgree[vv[temp][i]]==0)
                    q.push(vv[temp][i]);
            }
        }
        if(c!=n)//判环 拓扑完之后,如果存在点没有入队,那么这个点一定是环上的
            return 1;
        else
            return 0;
    }
    int main()
    {
        /*
        有向图判环 拓扑排序
        无向图判环 并查集 
        */
        int x,y;
        while(~scanf("%d %d",&n,&m))
        {
            if(n==0&&m==0)
                break;
            memset(indgree,0,sizeof(indgree));
            for(int i=1;i<=n;i++)
                vv[i].clear();
            int flag=0;
            for(int i=1;i<=m;i++)
            {
                scanf("%d %d",&x,&y);
                x++,y++;
                if(x==y)
                    continue;
                if(count(vv[x].begin(),vv[x].end(),y)==0)//防重边
                {
                    vv[x].push_back(y);
                    indgree[y]++;
                }
                if(count(vv[y].begin(),vv[y].end(),x)!=0)//环的一种
                {
                    flag=1;
                }
            }
            flag=tpsort();
            if(flag)
                printf("NO
    ");
            else
                printf("YES
    ");
        }
        return 0;
    }
     
  • 相关阅读:
    7-31 jmu-分段函数l (20 分)
    7-29 jmu-python-不同进制数 (10 分)
    7-28 摄氏温度转换华氏温度 (5 分)
    7-23 图的字典表示 (20 分)
    7-24 判断素数 (20 分)
    7-22 输出10个不重复的英文字母 (50 分)
    【转载】C#批量插入数据到Sqlserver中的三种方式
    天气预报api-汇总
    【转载】VS2015 + EF6连接MYSQL5.6
    【转摘】TFS上分支和标签的用法
  • 原文地址:https://www.cnblogs.com/yinbiao/p/9843884.html
Copyright © 2020-2023  润新知